
;
;
;             Sin/Cos-generator Test
;          
; ---------------       Copyright (c) 1997
;                       by Frank Baumgartner.
;                       (aka frank^riot)
;
; * Assemble with TASM v3.2+...
;
; E-mail: frank@itc.or.at, Fido: 2:317/11.81
;
;

	
	.586
	.MODEL FLAT
	ASSUME CS:CODE

	STACK 200h

	DATA SEGMENT PARA PUBLIC 'DATA'
	DATA ENDS

	CODE SEGMENT PARA PUBLIC 'CODE'
	CODE ENDS


include dpmi.inc                        ;low-level support
include vbe20.inc

include cpuid.inc
include sincos.inc


;


	CODE SEGMENT

start:
	push    ds                      ;set up segments...
	pop     es

	call	precalc_sincos		;precalc sin/cos table

	call    pentium_detect          ;Pentium-detection

	call    VBE_detect              ;VESA detection

	mov     cx, 640                 ;init video mode!
	mov     dx, 480
	mov     bl, 8
	call    VBE_initmode
	jnc     VBE_okay

	mov     ah, 09h                 ;vesa-mode not found, exit or
	mov     edx, OFFSET VBE_err002  ;maybe search an alternative mode
	int     21h                     ;here!

	mov     ah, 4ch
	int     21h

VBE_okay:                               ;--- in video-mode here ---
     
	mov     ecx, SINCOS_PERIOD      ;--- display sine-wave ---        
@@disp:
	movzx   ebx, cx
	shl     ebx, 2
	mov     eax, sine[ebx]

	push    ecx

	mov     ebx, ecx

	sar     eax, 30 - 6
	neg	eax
	add	eax, 100
	mov     ecx, 640
	mul     ecx
	mov     edi, eax
	add	edi, VBE_screen
	mov     [edi + ebx], byte ptr 15

	pop     ecx
	loop    @@disp
;---      
	mov     ax, 0c00h               ;flush keybd.-buffer
	int     21h

	xor     ax, ax                  ; wait 4 key 
	int     16h

	mov     ax, 0c00h               ;flush keybd.-buffer
	int     21h

	call    VBE_deinit              ;restore old video-mode

	mov     ah, 4ch                 ;back 2 dos...
	int     21h

	CODE ENDS

;


	END start


